/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  Signer,
  utils,
} from "ethers";
import type { EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../common";

export interface OspEventsInterface extends utils.Interface {
  functions: {};

  events: {
    "BaseInitialized(string,string,uint256)": EventFragment;
    "BaseURISet(string,uint256)": EventFragment;
    "CollectModuleWhitelisted(address,bool,uint256)": EventFragment;
    "CollectNFTDeployed(uint256,uint256,address,uint256)": EventFragment;
    "CollectNFTInitialized(uint256,uint256,uint256)": EventFragment;
    "CollectNFTTransferred(uint256,uint256,uint256,address,address,uint256)": EventFragment;
    "Collected(address,uint256,uint256,uint256,uint256,bytes,uint256)": EventFragment;
    "CommunityConditionWhitelisted(address,bool,uint256)": EventFragment;
    "CommunityCreated(uint256,address,uint256,string,address,bytes,address,bytes,address,uint256)": EventFragment;
    "CommunityHandleReserve(bytes32,bool,string,uint256)": EventFragment;
    "CommunityNFTTransferred(uint256,address,address,uint256)": EventFragment;
    "ContentReactionCreated(uint256,uint256,uint8,string,uint256,uint256,bytes,address,bytes,uint256)": EventFragment;
    "DispatcherSet(uint256,address,uint256)": EventFragment;
    "EmergencyAdminSet(address,address,address,uint256)": EventFragment;
    "FollowModuleSet(uint256,address,bytes,uint256)": EventFragment;
    "FollowModuleWhitelisted(address,bool,uint256)": EventFragment;
    "FollowSBTDeployed(uint256,address,uint256)": EventFragment;
    "FollowSBTInitialized(uint256,uint256)": EventFragment;
    "FollowSBTTransferred(uint256,uint256,address,address,uint256)": EventFragment;
    "Followed(address,uint256,uint256[],bytes[],uint256)": EventFragment;
    "FollowsApproved(address,uint256,address[],bool[],uint256)": EventFragment;
    "GovernanceSet(address,address,address,uint256)": EventFragment;
    "JoinModuleSet(uint256,address,bytes,uint256)": EventFragment;
    "JoinModuleWhitelisted(address,bool,uint256)": EventFragment;
    "JoinNFTDeployed(uint256,address,uint256)": EventFragment;
    "JoinNFTInitialized(uint256,uint256)": EventFragment;
    "JoinNFTTransferred(uint256,uint256,address,address,uint256)": EventFragment;
    "Joined(address,uint256,uint256,bytes,uint256)": EventFragment;
    "ModuleBaseConstructed(address,uint256)": EventFragment;
    "ModuleGlobalsCurrencyWhitelisted(address,bool,bool,uint256)": EventFragment;
    "ModuleGlobalsGovernanceSet(address,address,uint256)": EventFragment;
    "ModuleGlobalsTreasuryFeeSet(uint16,uint16,uint256)": EventFragment;
    "ModuleGlobalsTreasurySet(address,address,uint256)": EventFragment;
    "OSPInitialized(string,string,address,address,address,address,uint256)": EventFragment;
    "PostCreated(uint256,uint256,uint256,string,address,bytes,address,bytes,uint256)": EventFragment;
    "ProfileCreated(uint256,address,address,string,address,bytes,uint256)": EventFragment;
    "ReactionCreated(uint256,uint8,uint256,uint256,bytes,bytes,uint256)": EventFragment;
    "ReferenceModuleWhitelisted(address,bool,uint256)": EventFragment;
    "StateSet(address,uint8,uint8,uint256)": EventFragment;
    "SuperCommunityCreatorWhitelisted(address,bool,uint256)": EventFragment;
    "TokenWhitelisted(address,bool,uint256)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "BaseInitialized"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "BaseURISet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CollectModuleWhitelisted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CollectNFTDeployed"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CollectNFTInitialized"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CollectNFTTransferred"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Collected"): EventFragment;
  getEvent(
    nameOrSignatureOrTopic: "CommunityConditionWhitelisted"
  ): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CommunityCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CommunityHandleReserve"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CommunityNFTTransferred"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ContentReactionCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "DispatcherSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "EmergencyAdminSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "FollowModuleSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "FollowModuleWhitelisted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "FollowSBTDeployed"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "FollowSBTInitialized"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "FollowSBTTransferred"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Followed"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "FollowsApproved"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "GovernanceSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "JoinModuleSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "JoinModuleWhitelisted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "JoinNFTDeployed"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "JoinNFTInitialized"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "JoinNFTTransferred"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Joined"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ModuleBaseConstructed"): EventFragment;
  getEvent(
    nameOrSignatureOrTopic: "ModuleGlobalsCurrencyWhitelisted"
  ): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ModuleGlobalsGovernanceSet"): EventFragment;
  getEvent(
    nameOrSignatureOrTopic: "ModuleGlobalsTreasuryFeeSet"
  ): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ModuleGlobalsTreasurySet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "OSPInitialized"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PostCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ProfileCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ReactionCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ReferenceModuleWhitelisted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "StateSet"): EventFragment;
  getEvent(
    nameOrSignatureOrTopic: "SuperCommunityCreatorWhitelisted"
  ): EventFragment;
  getEvent(nameOrSignatureOrTopic: "TokenWhitelisted"): EventFragment;
}

export interface BaseInitializedEventObject {
  name: string;
  symbol: string;
  timestamp: BigNumber;
}
export type BaseInitializedEvent = TypedEvent<
  [string, string, BigNumber],
  BaseInitializedEventObject
>;

export type BaseInitializedEventFilter = TypedEventFilter<BaseInitializedEvent>;

export interface BaseURISetEventObject {
  communityNFTBaseURI: string;
  timestamp: BigNumber;
}
export type BaseURISetEvent = TypedEvent<
  [string, BigNumber],
  BaseURISetEventObject
>;

export type BaseURISetEventFilter = TypedEventFilter<BaseURISetEvent>;

export interface CollectModuleWhitelistedEventObject {
  collectModule: string;
  whitelisted: boolean;
  timestamp: BigNumber;
}
export type CollectModuleWhitelistedEvent = TypedEvent<
  [string, boolean, BigNumber],
  CollectModuleWhitelistedEventObject
>;

export type CollectModuleWhitelistedEventFilter =
  TypedEventFilter<CollectModuleWhitelistedEvent>;

export interface CollectNFTDeployedEventObject {
  profileId: BigNumber;
  contentId: BigNumber;
  collectNFT: string;
  timestamp: BigNumber;
}
export type CollectNFTDeployedEvent = TypedEvent<
  [BigNumber, BigNumber, string, BigNumber],
  CollectNFTDeployedEventObject
>;

export type CollectNFTDeployedEventFilter =
  TypedEventFilter<CollectNFTDeployedEvent>;

export interface CollectNFTInitializedEventObject {
  profileId: BigNumber;
  contentId: BigNumber;
  timestamp: BigNumber;
}
export type CollectNFTInitializedEvent = TypedEvent<
  [BigNumber, BigNumber, BigNumber],
  CollectNFTInitializedEventObject
>;

export type CollectNFTInitializedEventFilter =
  TypedEventFilter<CollectNFTInitializedEvent>;

export interface CollectNFTTransferredEventObject {
  profileId: BigNumber;
  contentId: BigNumber;
  collectNFTId: BigNumber;
  from: string;
  to: string;
  timestamp: BigNumber;
}
export type CollectNFTTransferredEvent = TypedEvent<
  [BigNumber, BigNumber, BigNumber, string, string, BigNumber],
  CollectNFTTransferredEventObject
>;

export type CollectNFTTransferredEventFilter =
  TypedEventFilter<CollectNFTTransferredEvent>;

export interface CollectedEventObject {
  collector: string;
  profileId: BigNumber;
  contentId: BigNumber;
  rootProfileId: BigNumber;
  rootcontentId: BigNumber;
  collectModuleData: string;
  timestamp: BigNumber;
}
export type CollectedEvent = TypedEvent<
  [string, BigNumber, BigNumber, BigNumber, BigNumber, string, BigNumber],
  CollectedEventObject
>;

export type CollectedEventFilter = TypedEventFilter<CollectedEvent>;

export interface CommunityConditionWhitelistedEventObject {
  communityCondition: string;
  whitelisted: boolean;
  timestamp: BigNumber;
}
export type CommunityConditionWhitelistedEvent = TypedEvent<
  [string, boolean, BigNumber],
  CommunityConditionWhitelistedEventObject
>;

export type CommunityConditionWhitelistedEventFilter =
  TypedEventFilter<CommunityConditionWhitelistedEvent>;

export interface CommunityCreatedEventObject {
  communityId: BigNumber;
  to: string;
  profileId: BigNumber;
  handle: string;
  conditon: string;
  conditionInitData: string;
  joinModule: string;
  joinModuleInitData: string;
  joinNFT: string;
  timestamp: BigNumber;
}
export type CommunityCreatedEvent = TypedEvent<
  [
    BigNumber,
    string,
    BigNumber,
    string,
    string,
    string,
    string,
    string,
    string,
    BigNumber
  ],
  CommunityCreatedEventObject
>;

export type CommunityCreatedEventFilter =
  TypedEventFilter<CommunityCreatedEvent>;

export interface CommunityHandleReserveEventObject {
  handleHash: string;
  isReserved: boolean;
  handle: string;
  timestamp: BigNumber;
}
export type CommunityHandleReserveEvent = TypedEvent<
  [string, boolean, string, BigNumber],
  CommunityHandleReserveEventObject
>;

export type CommunityHandleReserveEventFilter =
  TypedEventFilter<CommunityHandleReserveEvent>;

export interface CommunityNFTTransferredEventObject {
  communityId: BigNumber;
  from: string;
  to: string;
  timestamp: BigNumber;
}
export type CommunityNFTTransferredEvent = TypedEvent<
  [BigNumber, string, string, BigNumber],
  CommunityNFTTransferredEventObject
>;

export type CommunityNFTTransferredEventFilter =
  TypedEventFilter<CommunityNFTTransferredEvent>;

export interface ContentReactionCreatedEventObject {
  profileId: BigNumber;
  contentId: BigNumber;
  contentType: number;
  contentURI: string;
  referencedProfileId: BigNumber;
  referencedContentId: BigNumber;
  referenceModuleData: string;
  referenceModule: string;
  referenceModuleInitData: string;
  timestamp: BigNumber;
}
export type ContentReactionCreatedEvent = TypedEvent<
  [
    BigNumber,
    BigNumber,
    number,
    string,
    BigNumber,
    BigNumber,
    string,
    string,
    string,
    BigNumber
  ],
  ContentReactionCreatedEventObject
>;

export type ContentReactionCreatedEventFilter =
  TypedEventFilter<ContentReactionCreatedEvent>;

export interface DispatcherSetEventObject {
  profileId: BigNumber;
  dispatcher: string;
  timestamp: BigNumber;
}
export type DispatcherSetEvent = TypedEvent<
  [BigNumber, string, BigNumber],
  DispatcherSetEventObject
>;

export type DispatcherSetEventFilter = TypedEventFilter<DispatcherSetEvent>;

export interface EmergencyAdminSetEventObject {
  caller: string;
  oldEmergencyAdmin: string;
  newEmergencyAdmin: string;
  timestamp: BigNumber;
}
export type EmergencyAdminSetEvent = TypedEvent<
  [string, string, string, BigNumber],
  EmergencyAdminSetEventObject
>;

export type EmergencyAdminSetEventFilter =
  TypedEventFilter<EmergencyAdminSetEvent>;

export interface FollowModuleSetEventObject {
  profileId: BigNumber;
  followModule: string;
  followModuleInitData: string;
  timestamp: BigNumber;
}
export type FollowModuleSetEvent = TypedEvent<
  [BigNumber, string, string, BigNumber],
  FollowModuleSetEventObject
>;

export type FollowModuleSetEventFilter = TypedEventFilter<FollowModuleSetEvent>;

export interface FollowModuleWhitelistedEventObject {
  followModule: string;
  whitelisted: boolean;
  timestamp: BigNumber;
}
export type FollowModuleWhitelistedEvent = TypedEvent<
  [string, boolean, BigNumber],
  FollowModuleWhitelistedEventObject
>;

export type FollowModuleWhitelistedEventFilter =
  TypedEventFilter<FollowModuleWhitelistedEvent>;

export interface FollowSBTDeployedEventObject {
  profileId: BigNumber;
  followSBT: string;
  timestamp: BigNumber;
}
export type FollowSBTDeployedEvent = TypedEvent<
  [BigNumber, string, BigNumber],
  FollowSBTDeployedEventObject
>;

export type FollowSBTDeployedEventFilter =
  TypedEventFilter<FollowSBTDeployedEvent>;

export interface FollowSBTInitializedEventObject {
  profileId: BigNumber;
  timestamp: BigNumber;
}
export type FollowSBTInitializedEvent = TypedEvent<
  [BigNumber, BigNumber],
  FollowSBTInitializedEventObject
>;

export type FollowSBTInitializedEventFilter =
  TypedEventFilter<FollowSBTInitializedEvent>;

export interface FollowSBTTransferredEventObject {
  profileId: BigNumber;
  followSBTId: BigNumber;
  from: string;
  to: string;
  timestamp: BigNumber;
}
export type FollowSBTTransferredEvent = TypedEvent<
  [BigNumber, BigNumber, string, string, BigNumber],
  FollowSBTTransferredEventObject
>;

export type FollowSBTTransferredEventFilter =
  TypedEventFilter<FollowSBTTransferredEvent>;

export interface FollowedEventObject {
  follower: string;
  followerProfileId: BigNumber;
  profileIds: BigNumber[];
  followModuleDatas: string[];
  timestamp: BigNumber;
}
export type FollowedEvent = TypedEvent<
  [string, BigNumber, BigNumber[], string[], BigNumber],
  FollowedEventObject
>;

export type FollowedEventFilter = TypedEventFilter<FollowedEvent>;

export interface FollowsApprovedEventObject {
  owner: string;
  profileId: BigNumber;
  addresses: string[];
  approved: boolean[];
  timestamp: BigNumber;
}
export type FollowsApprovedEvent = TypedEvent<
  [string, BigNumber, string[], boolean[], BigNumber],
  FollowsApprovedEventObject
>;

export type FollowsApprovedEventFilter = TypedEventFilter<FollowsApprovedEvent>;

export interface GovernanceSetEventObject {
  caller: string;
  prevGovernance: string;
  newGovernance: string;
  timestamp: BigNumber;
}
export type GovernanceSetEvent = TypedEvent<
  [string, string, string, BigNumber],
  GovernanceSetEventObject
>;

export type GovernanceSetEventFilter = TypedEventFilter<GovernanceSetEvent>;

export interface JoinModuleSetEventObject {
  communityId: BigNumber;
  joinModule: string;
  joinModuleInitData: string;
  timestamp: BigNumber;
}
export type JoinModuleSetEvent = TypedEvent<
  [BigNumber, string, string, BigNumber],
  JoinModuleSetEventObject
>;

export type JoinModuleSetEventFilter = TypedEventFilter<JoinModuleSetEvent>;

export interface JoinModuleWhitelistedEventObject {
  joinModule: string;
  whitelisted: boolean;
  timestamp: BigNumber;
}
export type JoinModuleWhitelistedEvent = TypedEvent<
  [string, boolean, BigNumber],
  JoinModuleWhitelistedEventObject
>;

export type JoinModuleWhitelistedEventFilter =
  TypedEventFilter<JoinModuleWhitelistedEvent>;

export interface JoinNFTDeployedEventObject {
  communityId: BigNumber;
  joinNFT: string;
  timestamp: BigNumber;
}
export type JoinNFTDeployedEvent = TypedEvent<
  [BigNumber, string, BigNumber],
  JoinNFTDeployedEventObject
>;

export type JoinNFTDeployedEventFilter = TypedEventFilter<JoinNFTDeployedEvent>;

export interface JoinNFTInitializedEventObject {
  communityId: BigNumber;
  timestamp: BigNumber;
}
export type JoinNFTInitializedEvent = TypedEvent<
  [BigNumber, BigNumber],
  JoinNFTInitializedEventObject
>;

export type JoinNFTInitializedEventFilter =
  TypedEventFilter<JoinNFTInitializedEvent>;

export interface JoinNFTTransferredEventObject {
  communityId: BigNumber;
  joinNFTId: BigNumber;
  from: string;
  to: string;
  timestamp: BigNumber;
}
export type JoinNFTTransferredEvent = TypedEvent<
  [BigNumber, BigNumber, string, string, BigNumber],
  JoinNFTTransferredEventObject
>;

export type JoinNFTTransferredEventFilter =
  TypedEventFilter<JoinNFTTransferredEvent>;

export interface JoinedEventObject {
  joiner: string;
  communityId: BigNumber;
  joinerProfileId: BigNumber;
  joinModuleData: string;
  timestamp: BigNumber;
}
export type JoinedEvent = TypedEvent<
  [string, BigNumber, BigNumber, string, BigNumber],
  JoinedEventObject
>;

export type JoinedEventFilter = TypedEventFilter<JoinedEvent>;

export interface ModuleBaseConstructedEventObject {
  osp: string;
  timestamp: BigNumber;
}
export type ModuleBaseConstructedEvent = TypedEvent<
  [string, BigNumber],
  ModuleBaseConstructedEventObject
>;

export type ModuleBaseConstructedEventFilter =
  TypedEventFilter<ModuleBaseConstructedEvent>;

export interface ModuleGlobalsCurrencyWhitelistedEventObject {
  currency: string;
  prevWhitelisted: boolean;
  whitelisted: boolean;
  timestamp: BigNumber;
}
export type ModuleGlobalsCurrencyWhitelistedEvent = TypedEvent<
  [string, boolean, boolean, BigNumber],
  ModuleGlobalsCurrencyWhitelistedEventObject
>;

export type ModuleGlobalsCurrencyWhitelistedEventFilter =
  TypedEventFilter<ModuleGlobalsCurrencyWhitelistedEvent>;

export interface ModuleGlobalsGovernanceSetEventObject {
  prevGovernance: string;
  newGovernance: string;
  timestamp: BigNumber;
}
export type ModuleGlobalsGovernanceSetEvent = TypedEvent<
  [string, string, BigNumber],
  ModuleGlobalsGovernanceSetEventObject
>;

export type ModuleGlobalsGovernanceSetEventFilter =
  TypedEventFilter<ModuleGlobalsGovernanceSetEvent>;

export interface ModuleGlobalsTreasuryFeeSetEventObject {
  prevTreasuryFee: number;
  newTreasuryFee: number;
  timestamp: BigNumber;
}
export type ModuleGlobalsTreasuryFeeSetEvent = TypedEvent<
  [number, number, BigNumber],
  ModuleGlobalsTreasuryFeeSetEventObject
>;

export type ModuleGlobalsTreasuryFeeSetEventFilter =
  TypedEventFilter<ModuleGlobalsTreasuryFeeSetEvent>;

export interface ModuleGlobalsTreasurySetEventObject {
  prevTreasury: string;
  newTreasury: string;
  timestamp: BigNumber;
}
export type ModuleGlobalsTreasurySetEvent = TypedEvent<
  [string, string, BigNumber],
  ModuleGlobalsTreasurySetEventObject
>;

export type ModuleGlobalsTreasurySetEventFilter =
  TypedEventFilter<ModuleGlobalsTreasurySetEvent>;

export interface OSPInitializedEventObject {
  name: string;
  symbol: string;
  collectNFTImpl: string;
  followSBTImpl: string;
  joinNFTImpl: string;
  communityNFT: string;
  timestamp: BigNumber;
}
export type OSPInitializedEvent = TypedEvent<
  [string, string, string, string, string, string, BigNumber],
  OSPInitializedEventObject
>;

export type OSPInitializedEventFilter = TypedEventFilter<OSPInitializedEvent>;

export interface PostCreatedEventObject {
  profileId: BigNumber;
  contentId: BigNumber;
  communityId: BigNumber;
  contentURI: string;
  collectModule: string;
  collectModuleInitData: string;
  referenceModule: string;
  referenceModuleInitData: string;
  timestamp: BigNumber;
}
export type PostCreatedEvent = TypedEvent<
  [
    BigNumber,
    BigNumber,
    BigNumber,
    string,
    string,
    string,
    string,
    string,
    BigNumber
  ],
  PostCreatedEventObject
>;

export type PostCreatedEventFilter = TypedEventFilter<PostCreatedEvent>;

export interface ProfileCreatedEventObject {
  profileId: BigNumber;
  creator: string;
  to: string;
  handle: string;
  followModule: string;
  followModuleInitData: string;
  timestamp: BigNumber;
}
export type ProfileCreatedEvent = TypedEvent<
  [BigNumber, string, string, string, string, string, BigNumber],
  ProfileCreatedEventObject
>;

export type ProfileCreatedEventFilter = TypedEventFilter<ProfileCreatedEvent>;

export interface ReactionCreatedEventObject {
  profileId: BigNumber;
  reactionType: number;
  referencedProfileId: BigNumber;
  referencedContentId: BigNumber;
  referenceModuleData: string;
  data: string;
  timestamp: BigNumber;
}
export type ReactionCreatedEvent = TypedEvent<
  [BigNumber, number, BigNumber, BigNumber, string, string, BigNumber],
  ReactionCreatedEventObject
>;

export type ReactionCreatedEventFilter = TypedEventFilter<ReactionCreatedEvent>;

export interface ReferenceModuleWhitelistedEventObject {
  referenceModule: string;
  whitelisted: boolean;
  timestamp: BigNumber;
}
export type ReferenceModuleWhitelistedEvent = TypedEvent<
  [string, boolean, BigNumber],
  ReferenceModuleWhitelistedEventObject
>;

export type ReferenceModuleWhitelistedEventFilter =
  TypedEventFilter<ReferenceModuleWhitelistedEvent>;

export interface StateSetEventObject {
  caller: string;
  prevState: number;
  newState: number;
  timestamp: BigNumber;
}
export type StateSetEvent = TypedEvent<
  [string, number, number, BigNumber],
  StateSetEventObject
>;

export type StateSetEventFilter = TypedEventFilter<StateSetEvent>;

export interface SuperCommunityCreatorWhitelistedEventObject {
  superCommunityCreator: string;
  whitelisted: boolean;
  timestamp: BigNumber;
}
export type SuperCommunityCreatorWhitelistedEvent = TypedEvent<
  [string, boolean, BigNumber],
  SuperCommunityCreatorWhitelistedEventObject
>;

export type SuperCommunityCreatorWhitelistedEventFilter =
  TypedEventFilter<SuperCommunityCreatorWhitelistedEvent>;

export interface TokenWhitelistedEventObject {
  token: string;
  whitelisted: boolean;
  timestamp: BigNumber;
}
export type TokenWhitelistedEvent = TypedEvent<
  [string, boolean, BigNumber],
  TokenWhitelistedEventObject
>;

export type TokenWhitelistedEventFilter =
  TypedEventFilter<TokenWhitelistedEvent>;

export interface OspEvents extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: OspEventsInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {};

  callStatic: {};

  filters: {
    "BaseInitialized(string,string,uint256)"(
      name?: null,
      symbol?: null,
      timestamp?: null
    ): BaseInitializedEventFilter;
    BaseInitialized(
      name?: null,
      symbol?: null,
      timestamp?: null
    ): BaseInitializedEventFilter;

    "BaseURISet(string,uint256)"(
      communityNFTBaseURI?: null,
      timestamp?: null
    ): BaseURISetEventFilter;
    BaseURISet(
      communityNFTBaseURI?: null,
      timestamp?: null
    ): BaseURISetEventFilter;

    "CollectModuleWhitelisted(address,bool,uint256)"(
      collectModule?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): CollectModuleWhitelistedEventFilter;
    CollectModuleWhitelisted(
      collectModule?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): CollectModuleWhitelistedEventFilter;

    "CollectNFTDeployed(uint256,uint256,address,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      collectNFT?: PromiseOrValue<string> | null,
      timestamp?: null
    ): CollectNFTDeployedEventFilter;
    CollectNFTDeployed(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      collectNFT?: PromiseOrValue<string> | null,
      timestamp?: null
    ): CollectNFTDeployedEventFilter;

    "CollectNFTInitialized(uint256,uint256,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): CollectNFTInitializedEventFilter;
    CollectNFTInitialized(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): CollectNFTInitializedEventFilter;

    "CollectNFTTransferred(uint256,uint256,uint256,address,address,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      collectNFTId?: PromiseOrValue<BigNumberish> | null,
      from?: null,
      to?: null,
      timestamp?: null
    ): CollectNFTTransferredEventFilter;
    CollectNFTTransferred(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      collectNFTId?: PromiseOrValue<BigNumberish> | null,
      from?: null,
      to?: null,
      timestamp?: null
    ): CollectNFTTransferredEventFilter;

    "Collected(address,uint256,uint256,uint256,uint256,bytes,uint256)"(
      collector?: PromiseOrValue<string> | null,
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      rootProfileId?: null,
      rootcontentId?: null,
      collectModuleData?: null,
      timestamp?: null
    ): CollectedEventFilter;
    Collected(
      collector?: PromiseOrValue<string> | null,
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      rootProfileId?: null,
      rootcontentId?: null,
      collectModuleData?: null,
      timestamp?: null
    ): CollectedEventFilter;

    "CommunityConditionWhitelisted(address,bool,uint256)"(
      communityCondition?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): CommunityConditionWhitelistedEventFilter;
    CommunityConditionWhitelisted(
      communityCondition?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): CommunityConditionWhitelistedEventFilter;

    "CommunityCreated(uint256,address,uint256,string,address,bytes,address,bytes,address,uint256)"(
      communityId?: PromiseOrValue<BigNumberish> | null,
      to?: PromiseOrValue<string> | null,
      profileId?: null,
      handle?: null,
      conditon?: null,
      conditionInitData?: null,
      joinModule?: null,
      joinModuleInitData?: null,
      joinNFT?: null,
      timestamp?: null
    ): CommunityCreatedEventFilter;
    CommunityCreated(
      communityId?: PromiseOrValue<BigNumberish> | null,
      to?: PromiseOrValue<string> | null,
      profileId?: null,
      handle?: null,
      conditon?: null,
      conditionInitData?: null,
      joinModule?: null,
      joinModuleInitData?: null,
      joinNFT?: null,
      timestamp?: null
    ): CommunityCreatedEventFilter;

    "CommunityHandleReserve(bytes32,bool,string,uint256)"(
      handleHash?: PromiseOrValue<BytesLike> | null,
      isReserved?: PromiseOrValue<boolean> | null,
      handle?: null,
      timestamp?: null
    ): CommunityHandleReserveEventFilter;
    CommunityHandleReserve(
      handleHash?: PromiseOrValue<BytesLike> | null,
      isReserved?: PromiseOrValue<boolean> | null,
      handle?: null,
      timestamp?: null
    ): CommunityHandleReserveEventFilter;

    "CommunityNFTTransferred(uint256,address,address,uint256)"(
      communityId?: PromiseOrValue<BigNumberish> | null,
      from?: null,
      to?: null,
      timestamp?: null
    ): CommunityNFTTransferredEventFilter;
    CommunityNFTTransferred(
      communityId?: PromiseOrValue<BigNumberish> | null,
      from?: null,
      to?: null,
      timestamp?: null
    ): CommunityNFTTransferredEventFilter;

    "ContentReactionCreated(uint256,uint256,uint8,string,uint256,uint256,bytes,address,bytes,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      contentType?: null,
      contentURI?: null,
      referencedProfileId?: null,
      referencedContentId?: null,
      referenceModuleData?: null,
      referenceModule?: null,
      referenceModuleInitData?: null,
      timestamp?: null
    ): ContentReactionCreatedEventFilter;
    ContentReactionCreated(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      contentType?: null,
      contentURI?: null,
      referencedProfileId?: null,
      referencedContentId?: null,
      referenceModuleData?: null,
      referenceModule?: null,
      referenceModuleInitData?: null,
      timestamp?: null
    ): ContentReactionCreatedEventFilter;

    "DispatcherSet(uint256,address,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      dispatcher?: PromiseOrValue<string> | null,
      timestamp?: null
    ): DispatcherSetEventFilter;
    DispatcherSet(
      profileId?: PromiseOrValue<BigNumberish> | null,
      dispatcher?: PromiseOrValue<string> | null,
      timestamp?: null
    ): DispatcherSetEventFilter;

    "EmergencyAdminSet(address,address,address,uint256)"(
      caller?: PromiseOrValue<string> | null,
      oldEmergencyAdmin?: PromiseOrValue<string> | null,
      newEmergencyAdmin?: PromiseOrValue<string> | null,
      timestamp?: null
    ): EmergencyAdminSetEventFilter;
    EmergencyAdminSet(
      caller?: PromiseOrValue<string> | null,
      oldEmergencyAdmin?: PromiseOrValue<string> | null,
      newEmergencyAdmin?: PromiseOrValue<string> | null,
      timestamp?: null
    ): EmergencyAdminSetEventFilter;

    "FollowModuleSet(uint256,address,bytes,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      followModule?: null,
      followModuleInitData?: null,
      timestamp?: null
    ): FollowModuleSetEventFilter;
    FollowModuleSet(
      profileId?: PromiseOrValue<BigNumberish> | null,
      followModule?: null,
      followModuleInitData?: null,
      timestamp?: null
    ): FollowModuleSetEventFilter;

    "FollowModuleWhitelisted(address,bool,uint256)"(
      followModule?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): FollowModuleWhitelistedEventFilter;
    FollowModuleWhitelisted(
      followModule?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): FollowModuleWhitelistedEventFilter;

    "FollowSBTDeployed(uint256,address,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      followSBT?: PromiseOrValue<string> | null,
      timestamp?: null
    ): FollowSBTDeployedEventFilter;
    FollowSBTDeployed(
      profileId?: PromiseOrValue<BigNumberish> | null,
      followSBT?: PromiseOrValue<string> | null,
      timestamp?: null
    ): FollowSBTDeployedEventFilter;

    "FollowSBTInitialized(uint256,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): FollowSBTInitializedEventFilter;
    FollowSBTInitialized(
      profileId?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): FollowSBTInitializedEventFilter;

    "FollowSBTTransferred(uint256,uint256,address,address,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      followSBTId?: PromiseOrValue<BigNumberish> | null,
      from?: null,
      to?: null,
      timestamp?: null
    ): FollowSBTTransferredEventFilter;
    FollowSBTTransferred(
      profileId?: PromiseOrValue<BigNumberish> | null,
      followSBTId?: PromiseOrValue<BigNumberish> | null,
      from?: null,
      to?: null,
      timestamp?: null
    ): FollowSBTTransferredEventFilter;

    "Followed(address,uint256,uint256[],bytes[],uint256)"(
      follower?: PromiseOrValue<string> | null,
      followerProfileId?: null,
      profileIds?: null,
      followModuleDatas?: null,
      timestamp?: null
    ): FollowedEventFilter;
    Followed(
      follower?: PromiseOrValue<string> | null,
      followerProfileId?: null,
      profileIds?: null,
      followModuleDatas?: null,
      timestamp?: null
    ): FollowedEventFilter;

    "FollowsApproved(address,uint256,address[],bool[],uint256)"(
      owner?: PromiseOrValue<string> | null,
      profileId?: PromiseOrValue<BigNumberish> | null,
      addresses?: null,
      approved?: null,
      timestamp?: null
    ): FollowsApprovedEventFilter;
    FollowsApproved(
      owner?: PromiseOrValue<string> | null,
      profileId?: PromiseOrValue<BigNumberish> | null,
      addresses?: null,
      approved?: null,
      timestamp?: null
    ): FollowsApprovedEventFilter;

    "GovernanceSet(address,address,address,uint256)"(
      caller?: PromiseOrValue<string> | null,
      prevGovernance?: PromiseOrValue<string> | null,
      newGovernance?: PromiseOrValue<string> | null,
      timestamp?: null
    ): GovernanceSetEventFilter;
    GovernanceSet(
      caller?: PromiseOrValue<string> | null,
      prevGovernance?: PromiseOrValue<string> | null,
      newGovernance?: PromiseOrValue<string> | null,
      timestamp?: null
    ): GovernanceSetEventFilter;

    "JoinModuleSet(uint256,address,bytes,uint256)"(
      communityId?: PromiseOrValue<BigNumberish> | null,
      joinModule?: null,
      joinModuleInitData?: null,
      timestamp?: null
    ): JoinModuleSetEventFilter;
    JoinModuleSet(
      communityId?: PromiseOrValue<BigNumberish> | null,
      joinModule?: null,
      joinModuleInitData?: null,
      timestamp?: null
    ): JoinModuleSetEventFilter;

    "JoinModuleWhitelisted(address,bool,uint256)"(
      joinModule?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): JoinModuleWhitelistedEventFilter;
    JoinModuleWhitelisted(
      joinModule?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): JoinModuleWhitelistedEventFilter;

    "JoinNFTDeployed(uint256,address,uint256)"(
      communityId?: PromiseOrValue<BigNumberish> | null,
      joinNFT?: PromiseOrValue<string> | null,
      timestamp?: null
    ): JoinNFTDeployedEventFilter;
    JoinNFTDeployed(
      communityId?: PromiseOrValue<BigNumberish> | null,
      joinNFT?: PromiseOrValue<string> | null,
      timestamp?: null
    ): JoinNFTDeployedEventFilter;

    "JoinNFTInitialized(uint256,uint256)"(
      communityId?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): JoinNFTInitializedEventFilter;
    JoinNFTInitialized(
      communityId?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): JoinNFTInitializedEventFilter;

    "JoinNFTTransferred(uint256,uint256,address,address,uint256)"(
      communityId?: PromiseOrValue<BigNumberish> | null,
      joinNFTId?: PromiseOrValue<BigNumberish> | null,
      from?: null,
      to?: null,
      timestamp?: null
    ): JoinNFTTransferredEventFilter;
    JoinNFTTransferred(
      communityId?: PromiseOrValue<BigNumberish> | null,
      joinNFTId?: PromiseOrValue<BigNumberish> | null,
      from?: null,
      to?: null,
      timestamp?: null
    ): JoinNFTTransferredEventFilter;

    "Joined(address,uint256,uint256,bytes,uint256)"(
      joiner?: PromiseOrValue<string> | null,
      communityId?: PromiseOrValue<BigNumberish> | null,
      joinerProfileId?: null,
      joinModuleData?: null,
      timestamp?: null
    ): JoinedEventFilter;
    Joined(
      joiner?: PromiseOrValue<string> | null,
      communityId?: PromiseOrValue<BigNumberish> | null,
      joinerProfileId?: null,
      joinModuleData?: null,
      timestamp?: null
    ): JoinedEventFilter;

    "ModuleBaseConstructed(address,uint256)"(
      osp?: PromiseOrValue<string> | null,
      timestamp?: null
    ): ModuleBaseConstructedEventFilter;
    ModuleBaseConstructed(
      osp?: PromiseOrValue<string> | null,
      timestamp?: null
    ): ModuleBaseConstructedEventFilter;

    "ModuleGlobalsCurrencyWhitelisted(address,bool,bool,uint256)"(
      currency?: PromiseOrValue<string> | null,
      prevWhitelisted?: PromiseOrValue<boolean> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): ModuleGlobalsCurrencyWhitelistedEventFilter;
    ModuleGlobalsCurrencyWhitelisted(
      currency?: PromiseOrValue<string> | null,
      prevWhitelisted?: PromiseOrValue<boolean> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): ModuleGlobalsCurrencyWhitelistedEventFilter;

    "ModuleGlobalsGovernanceSet(address,address,uint256)"(
      prevGovernance?: PromiseOrValue<string> | null,
      newGovernance?: PromiseOrValue<string> | null,
      timestamp?: null
    ): ModuleGlobalsGovernanceSetEventFilter;
    ModuleGlobalsGovernanceSet(
      prevGovernance?: PromiseOrValue<string> | null,
      newGovernance?: PromiseOrValue<string> | null,
      timestamp?: null
    ): ModuleGlobalsGovernanceSetEventFilter;

    "ModuleGlobalsTreasuryFeeSet(uint16,uint16,uint256)"(
      prevTreasuryFee?: PromiseOrValue<BigNumberish> | null,
      newTreasuryFee?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): ModuleGlobalsTreasuryFeeSetEventFilter;
    ModuleGlobalsTreasuryFeeSet(
      prevTreasuryFee?: PromiseOrValue<BigNumberish> | null,
      newTreasuryFee?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): ModuleGlobalsTreasuryFeeSetEventFilter;

    "ModuleGlobalsTreasurySet(address,address,uint256)"(
      prevTreasury?: PromiseOrValue<string> | null,
      newTreasury?: PromiseOrValue<string> | null,
      timestamp?: null
    ): ModuleGlobalsTreasurySetEventFilter;
    ModuleGlobalsTreasurySet(
      prevTreasury?: PromiseOrValue<string> | null,
      newTreasury?: PromiseOrValue<string> | null,
      timestamp?: null
    ): ModuleGlobalsTreasurySetEventFilter;

    "OSPInitialized(string,string,address,address,address,address,uint256)"(
      name?: null,
      symbol?: null,
      collectNFTImpl?: null,
      followSBTImpl?: null,
      joinNFTImpl?: null,
      communityNFT?: null,
      timestamp?: null
    ): OSPInitializedEventFilter;
    OSPInitialized(
      name?: null,
      symbol?: null,
      collectNFTImpl?: null,
      followSBTImpl?: null,
      joinNFTImpl?: null,
      communityNFT?: null,
      timestamp?: null
    ): OSPInitializedEventFilter;

    "PostCreated(uint256,uint256,uint256,string,address,bytes,address,bytes,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      communityId?: null,
      contentURI?: null,
      collectModule?: null,
      collectModuleInitData?: null,
      referenceModule?: null,
      referenceModuleInitData?: null,
      timestamp?: null
    ): PostCreatedEventFilter;
    PostCreated(
      profileId?: PromiseOrValue<BigNumberish> | null,
      contentId?: PromiseOrValue<BigNumberish> | null,
      communityId?: null,
      contentURI?: null,
      collectModule?: null,
      collectModuleInitData?: null,
      referenceModule?: null,
      referenceModuleInitData?: null,
      timestamp?: null
    ): PostCreatedEventFilter;

    "ProfileCreated(uint256,address,address,string,address,bytes,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      creator?: PromiseOrValue<string> | null,
      to?: PromiseOrValue<string> | null,
      handle?: null,
      followModule?: null,
      followModuleInitData?: null,
      timestamp?: null
    ): ProfileCreatedEventFilter;
    ProfileCreated(
      profileId?: PromiseOrValue<BigNumberish> | null,
      creator?: PromiseOrValue<string> | null,
      to?: PromiseOrValue<string> | null,
      handle?: null,
      followModule?: null,
      followModuleInitData?: null,
      timestamp?: null
    ): ProfileCreatedEventFilter;

    "ReactionCreated(uint256,uint8,uint256,uint256,bytes,bytes,uint256)"(
      profileId?: PromiseOrValue<BigNumberish> | null,
      reactionType?: null,
      referencedProfileId?: null,
      referencedContentId?: null,
      referenceModuleData?: null,
      data?: null,
      timestamp?: null
    ): ReactionCreatedEventFilter;
    ReactionCreated(
      profileId?: PromiseOrValue<BigNumberish> | null,
      reactionType?: null,
      referencedProfileId?: null,
      referencedContentId?: null,
      referenceModuleData?: null,
      data?: null,
      timestamp?: null
    ): ReactionCreatedEventFilter;

    "ReferenceModuleWhitelisted(address,bool,uint256)"(
      referenceModule?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): ReferenceModuleWhitelistedEventFilter;
    ReferenceModuleWhitelisted(
      referenceModule?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): ReferenceModuleWhitelistedEventFilter;

    "StateSet(address,uint8,uint8,uint256)"(
      caller?: PromiseOrValue<string> | null,
      prevState?: PromiseOrValue<BigNumberish> | null,
      newState?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): StateSetEventFilter;
    StateSet(
      caller?: PromiseOrValue<string> | null,
      prevState?: PromiseOrValue<BigNumberish> | null,
      newState?: PromiseOrValue<BigNumberish> | null,
      timestamp?: null
    ): StateSetEventFilter;

    "SuperCommunityCreatorWhitelisted(address,bool,uint256)"(
      superCommunityCreator?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): SuperCommunityCreatorWhitelistedEventFilter;
    SuperCommunityCreatorWhitelisted(
      superCommunityCreator?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): SuperCommunityCreatorWhitelistedEventFilter;

    "TokenWhitelisted(address,bool,uint256)"(
      token?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): TokenWhitelistedEventFilter;
    TokenWhitelisted(
      token?: PromiseOrValue<string> | null,
      whitelisted?: PromiseOrValue<boolean> | null,
      timestamp?: null
    ): TokenWhitelistedEventFilter;
  };

  estimateGas: {};

  populateTransaction: {};
}
